

struct geeonx_appdata
{
	
	SDL_Event event; /* Here the events will be catched */
	TTF_Font *font;  /* TTF font pointer */
	SDL_Surface *screen; /* SDL Oberflaeche definieren */
	SDL_Surface *text_surface; /* SDL surface for text */
	SDL_Window *geeonx_window; /* SDL Oberflaeche definieren */
	SDL_Renderer *renderer; /* Renderer for SDL 2x */
	SDL_Texture *texture; /* Texture for SDL 2x */

	SDL_Rect hole_screen;

	unsigned char background_r;
	unsigned char background_g;
	unsigned char background_b;
	unsigned char selected_r;
	unsigned char selected_g;
	unsigned char selected_b;
	unsigned char size_r; /* new in 78 */
	unsigned char size_g;
	unsigned char size_b;
	unsigned char scroll_r; /* new in 79 */
	unsigned char scroll_g;
	unsigned char scroll_b;

	unsigned int screen_w;
	unsigned int screen_h;

	unsigned int switch_st_scroll_size;
	
	unsigned int scroll_speed; /* New in 83 */
	

	unsigned int key_storage_first;
	unsigned int key_storage_final;
	unsigned int letter;
	
	unsigned int selected_window; 
	unsigned int selected_object; 
	unsigned int numberofobjects; /* Pointer to number of read objects. */
	
	unsigned int numberofstreams; /* Pointer to number of read streams. */
	unsigned int in_new_object;          /* inside the object */
	unsigned int language; /* German is 1. */
	unsigned int active_cursor_object;   /* Who has got the cursor ?  */
	unsigned int insert_modus;   /* Insert or delete ? */
	unsigned int streams_active; /* New in 81. */
	unsigned char directory[300]; /* New in 82. */
	unsigned int dir_entry_counter; /* New in 82. */
	
	unsigned int message_channel[250]; /* New in 110 */
	unsigned char geeonx_app_entry[100][65];  /* New in 110 */
	
	unsigned char geeonx_dir_entry[100][65];       /* 0-64 New in 82. */
	unsigned int entry_ranking_list[100]; /* New in 112. */
	unsigned int window_ranking_list[100]; /* New in 112. */
	unsigned int active_windows;    /* New in 113. */
	struct geeonx_win_stream *win_stream; /* Address of stream_data. */
	struct geeonx_window_text *win_text; /* Address of win_text */
	struct geeonx_object *object_data; /* Address of objects. */
	struct geeonx_exp_object *import_data; /* Since 87 */
	
};





struct geeonx_object
{
int32_t obj_x;
int32_t obj_y;
uint32_t obj_w;
uint32_t obj_h;
uint32_t background_color_r;
uint32_t background_color_g;
uint32_t background_color_b;
uint8_t obj_text[65];					/*  0-64 and 64 is \0 */
uint32_t font_status;
uint32_t font_height;                  /* New in 75. */
uint8_t linked_font[65]; /* 0-64 64 is NULL */
TTF_Font *object_font; 				 /* New: TTF font pointer */
uint32_t stream_identifier;     
uint32_t text_color_r;
uint32_t text_color_g;
uint32_t text_color_b;
uint32_t text_distance_left;
uint32_t text_distance_right;
uint32_t text_distance_top;
uint32_t text_distance_bottom;
uint32_t text_align;
uint32_t size_of_line;
uint32_t line_gap;
uint32_t number_of_lines;
uint32_t selected;
uint32_t disabled;
uint32_t obj_status;
uint32_t fix_dialog;
uint32_t cursor_status;
int32_t cursor_x;
int32_t cursor_y;
uint32_t cursor_input_counter; 
uint32_t row;
uint32_t column;
uint32_t cursor_input_range; /* New in 73. */
uint32_t visual_effect; /* New in 99 */
uint32_t border_distance; 
uint32_t border_color_r; 
uint32_t border_color_g;
uint32_t border_color_b;
/* Killed image_status. */
uint32_t mother_object;
uint32_t move_with[100];  /* 0-99 */
int32_t text_extent_moved_w; /* values may be negative. */
int32_t text_extent_moved_h;
uint32_t max_extent_w;
uint32_t max_extent_h;
uint8_t linked_file[65]; /* 0-64 64 is NULL */
SDL_Surface *image_surface; /* SDL surface for images */
uint32_t out_of_textborders; /* NEw in 83. */
uint8_t *big_stream_address; /* New in 116 */
uint32_t position_in_big_stream; /* New in 118. */

};


struct geeonx_win_stream
{
	uint32_t object_number;  
	uint32_t position_in_stream;
	uint8_t object_text[1000];              /* 0-999 and 999 \0 */
};



struct geeonx_window_text
{
    unsigned char window_text[40][100];  /* large line 0-39 and 0-98 ->99 \0 */
};

__declspec(dllexport) void gee_activate_window(struct geeonx_appdata *myapp);

__declspec(dllexport) int gee_check_line_volume(struct geeonx_appdata *myapp, unsigned int number, unsigned char *p_text_word, unsigned int *p_line_counter, unsigned int *p_position_in_line, unsigned int *p_position_in_word);

__declspec(dllexport) int gee_count_string_size_without_zero(unsigned char *string); /* Since 103 */

__declspec(dllexport) void gee_close(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_close_win(struct geeonx_appdata *myapp, unsigned int number);

__declspec(dllexport) void gee_connect_object_to_big_stream(struct geeonx_appdata *myapp, unsigned number, unsigned int size_bytes); /* Since 118. */

__declspec(dllexport) unsigned int gee_copy_st_last_part(unsigned char *source_string, unsigned char *target_string);

__declspec(dllexport) void gee_copy_st_first_part(unsigned int endpoint, unsigned char *source_string, unsigned char *target_string);

__declspec(dllexport) unsigned int gee_decide_window(struct geeonx_appdata *myapp, unsigned int number, unsigned int choice_one, unsigned int choice_two);

__declspec(dllexport)void gee_draw_pixel (struct geeonx_appdata *myapp, unsigned int x, unsigned int y, unsigned char r, unsigned char g, unsigned char b);

__declspec(dllexport) void gee_draw_line(struct geeonx_appdata *myapp, unsigned int fx, unsigned int fy, unsigned int lx, unsigned int ly, unsigned char r, unsigned char g, unsigned char b);

__declspec(dllexport) void gee_draw_box(struct geeonx_appdata *myapp, unsigned int x, unsigned int y, unsigned int w, unsigned int h, unsigned char r, unsigned char g, unsigned char b);

__declspec(dllexport) void gee_draw_rectangle(struct geeonx_appdata *myapp, unsigned int x, unsigned int y, unsigned int w, unsigned int h, unsigned char r, unsigned char g, unsigned char b);

__declspec(dllexport) void gee_draw_selected_window(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_draw_and_screenup_selected_window(struct geeonx_appdata *myapp);

__declspec(dllexport) int gee_draw_all_objects(struct geeonx_appdata *myapp,unsigned int format, unsigned int redraw);

__declspec(dllexport) void gee_exa_left_pressed(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_exa_left_released(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_fill_form_with_dummies(struct geeonx_appdata *myapp, unsigned char *string, unsigned int form_number, unsigned int form_size, unsigned char dummy); /* Since 103. */

__declspec(dllexport) int gee_format_object_text(struct geeonx_appdata *myapp, unsigned int number);

__declspec(dllexport) int gee_format_small_obj(struct geeonx_appdata *myapp,unsigned int number);

__declspec(dllexport) void gee_format_stream_to_linked_objects(struct geeonx_appdata *myapp, unsigned int big_stream_mother); /* Since 116 */

__declspec(dllexport) void gee_get_column_row(struct geeonx_appdata *myapp); /* New in 105. */

__declspec(dllexport) unsigned int gee_get_column_row_big_stream(struct geeonx_appdata *myapp, unsigned int number); /* New in 118 */


__declspec(dllexport) void gee_get_position_in_stream(struct geeonx_appdata *myapp); /* New in 106. */

__declspec(dllexport) void gee_get_position_in_big_stream(struct geeonx_appdata *myapp); /* New in 122. */

__declspec(dllexport) int gee_get_lastposition_before_zero(unsigned char *string); /* New in 104 */

__declspec(dllexport) void gee_getfirstkeyinformation(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_getfinalkeyinformation(struct geeonx_appdata *myapp);

__declspec(dllexport) unsigned int gee_get_mono_mouse_selection(struct geeonx_appdata *myapp, unsigned int button);

__declspec(dllexport) unsigned int gee_get_mouse_selection(struct geeonx_appdata *myapp, unsigned int one, unsigned int two);

__declspec(dllexport) unsigned int gee_get_move_with_nr(struct geeonx_appdata *myapp, unsigned int mother_object, unsigned int dep_object); /* new in 123 */

__declspec(dllexport) void gee_get_text(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_get_big_stream_text(struct geeonx_appdata *myapp);

__declspec(dllexport) int gee_in_object(struct geeonx_appdata *myapp, unsigned int number, int x, int y);

__declspec(dllexport) void gee_lock (SDL_Surface *screen);

__declspec(dllexport) void gee_load_dir_entries(struct geeonx_appdata *myapp, unsigned int number);

/* Since 97 */
__declspec(dllexport) void gee_load_window_text(struct geeonx_appdata *myapp,unsigned int window_number, unsigned char *main_content_p);

__declspec(dllexport) void gee_load_window_text_buttons(struct geeonx_appdata *myapp,unsigned int window_number, unsigned char *main_content_p, unsigned int button_one, unsigned int button_two);

__declspec(dllexport) int gee_move_out_menu(struct geeonx_appdata *myapp, unsigned int number, unsigned int function);

__declspec(dllexport) void gee_notice_window(struct geeonx_appdata *myapp, unsigned int number, unsigned int mono_button);

__declspec(dllexport) void gee_prepare_fileselector(struct geeonx_appdata *myapp, unsigned int number, unsigned int last_move_with);

__declspec(dllexport) int gee_prepare_chain_mother(struct geeonx_appdata *myapp, unsigned int number, unsigned int size); /* Since 120 */

__declspec(dllexport) void gee_read_app_dir(struct geeonx_appdata *myapp);

__declspec(dllexport) char* gee_read_external_stream(unsigned char filename[]);

__declspec(dllexport) int gee_read_external_stream_copy_to_object(struct geeonx_appdata *myapp, unsigned char filename[],unsigned int number); /* New in 118. */

/* new in 83 */

__declspec(dllexport) void gee_reset_textobject(struct geeonx_appdata *myapp, unsigned int big_object, unsigned int number); /* new in 116 */

__declspec(dllexport) unsigned int gee_search_master(struct geeonx_appdata *myapp, unsigned int number);

__declspec(dllexport) void gee_set_operators(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_screenupdate(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_select_window(struct geeonx_appdata *myapp);

__declspec(dllexport) void gee_start_geeonx(struct geeonx_appdata *myapp, unsigned int agio, unsigned int stream_agio, char file_name[], char stream_name[]);

__declspec(dllexport) int gee_test_all_objects(struct geeonx_appdata *myapp, unsigned int x, unsigned int y);


__declspec(dllexport) void gee_transform_str_to_num(unsigned char *string, unsigned int *number); /* New in 97 */

__declspec(dllexport) int gee_transform_num_to_str(unsigned int *number, unsigned char *string);

__declspec(dllexport) int gee_transform_int_to_asccii(unsigned int number, unsigned char *ascii);

__declspec(dllexport) int gee_transform_ascii_to_int(unsigned int *number, unsigned char *ascii);


__declspec(dllexport) void gee_unlock (SDL_Surface *screen);

__declspec(dllexport) void gee_undraw_object(struct geeonx_appdata *myapp, unsigned int number);

__declspec(dllexport) unsigned int gee_zehnerpotenz(unsigned int exponent); /* New in 97 */

